//Bogdan FOLEA, 335CC - Proiect PM 2016

#include "gnuplot.h"

void gnuplot_setup(){
	//open pipe and supress output
	gnuplotPipe = popen("gnuplot > /dev/null 2>&1", "w");
	if(gnuplotPipe == NULL){
		fprintf(stderr,"error opening pipe to gnuplot\n");
             	exit(-1);
	}

	//clear settings
	gnuplot("reset");

	//aspect settings
	gnuplot("set clip points");
	gnuplot("unset border");
	gnuplot("set xzeroaxis");
	gnuplot("set yzeroaxis");
	gnuplot("set terminal wxt size 750,700");
	gnuplot("set size square");
	gnuplot("set size ratio -1");
	gnuplot("unset xtics");
	gnuplot("unset ytics");

	//title, key and labels
	gnuplot("set title  font 'Times-Roman,30'\
		textcolor rgb 'navy' 'RADAR CU ECOLOCAŢIE'");
	gnuplot("unset key");
	gnuplot("set arrow from 500,280 to 500,370 lw 2 lc rgb 'navy'");
	gnuplot("set label 1 'ORIENTARE' font 'Times-Roman,16'\
		textcolor rgb 'navy' at 290,350");	//Q1
	gnuplot("set label 2 'RADAR' font 'Times-Roman,16'\
		textcolor rgb 'navy' at 360,310");	//Q1
	gnuplot("set label 3 'BĂTAIE:' font 'Times-Roman,16'\
		textcolor rgb 'navy' at -460,350");	//Q2
	gnuplot("set label 4 '20-400 cm' font 'Times-Roman,16'\
		textcolor rgb 'navy' at -490,310");	//Q2
	gnuplot("set label 5 '© Bogdan Folea' font 'Times-Roman,16'\
		textcolor rgb 'navy' at -500,-380");	//Q3
	gnuplot("set label 6 'PM 2016' font 'Times-Roman,20'\
		textcolor rgb 'navy' at 320,-380");	//Q4

	//range, axes and grid
	gnuplot("set arrow from 10,0 to 500, 0");
	gnuplot("set label 7 'cm' font 'Times-Roman,10'\
		textcolor rgb 'black' at 460,-23");
	gnuplot("set polar");
	gnuplot("set angles degrees");
	gnuplot("set rrange [0:420]");
	gnuplot("set grid polar 30");
	gnuplot("set style line 101 lt 0 lw 1.5 pt 3");
	gnuplot("set grid layerdefault ls 101");

	//fit to window size
	gnuplot("plot 0");
	gnuplot("replot");
}

void *gnuplot_draw(){
	loop{
		if(flag == 1){
			int index, value, i;
			sscanf(par.buffer,"%d %d",&index,&value);
			if(value > 20 && value < 400)
				points[index]=value;
			else points[index]=0;

			aux("plot '-' with lines lw 5 lc rgb '#999999',\
			 '-' pt 26 ps 2 lc rgb 'red', '-' pt 25 ps 2 lc\
			 rgb 'navy'\n0 0\n%d 400\ne", index);
			for(i=0;i<=index;i++)
				if(points[i])
					aux("%d %d",i,points[i]);
			aux("e");
			for(i=index+1;i<=180;i++)
				if(points[i])
					aux("%d %d",i,points[i]);
			gnuplot("e");

			flag = 0;
		}
	}
}
