//Bogdan FOLEA, 335CC - Proiect PM 2016

#include <stdio.h>
#include <string.h>
#include <pthread.h>

#include "serial.h"
#include "gnuplot.h"

#define loop while(1)

void *input(){
	setbuf(stdout, NULL);
	char q;
	printf("type 'q' to quit:\n> ");
	scanf("%c",&q);
	fflush(stdout);
	while(q != 'q'){
		if(q != '\n') printf("> ");
		fflush(stdout);
		scanf("%c",&q);
	}
	fclose(gnuplotPipe);
	printf("successfully executed program\n");
	exit(0);
}

int main(int argc, char *argv[]) {
	//setup
	if(argc != 2){
		fprintf(stderr,"usage: %s <serial_port>\n", argv[0]);
		exit(-2);
	}
	gnuplot_setup(argv[1]);
	int fd = serial_setup(argv[1]);

	char buffer[10];

	//get in sync with radar
	printf("waiting to sync with radar..\n");
	while(!strstr(buffer,"reset")){
		serial_read(fd, buffer, 10);
	}

	//set up input thread
	pthread_t in;
	if(pthread_create (&in, NULL, input, NULL)){
		perror("failed creating thread");
		exit(1);
	}

	//set up GUI thread
	flag = 0;
	pthread_t gnuplot;
	if(pthread_create (&gnuplot, NULL, gnuplot_draw, NULL)){
		perror("failed creating thread");
		exit(1);
	}

	//main loop
	loop{
		int rc = serial_read(fd, buffer, 10);
		if(rc > 0 && !strstr(buffer,"reset")){
			strcpy(par.buffer,buffer);
			flag = 1;
		}
	}
}
