//Bogdan FOLEA, 335CC - Proiect PM 2016

#include <Servo.h>

#define motorPin 2
#define trigPin 3
#define echoPin 4
#define interval 20
#define pas 2

Servo motor;
int angle;
unsigned long crt, prev;

void setup() {
	angle = 181;
	crt = 0, prev = 0;

	//serial
	Serial.begin(9600);

	//sensor
	pinMode(trigPin,OUTPUT);
	pinMode(echoPin,INPUT);

	//motor
	motor.attach(motorPin);
	motor.write(0);
	delay(2000);
}

int getDistance(){
	int time, dist;

	digitalWrite(trigPin, LOW);
	delayMicroseconds(5);
	digitalWrite(trigPin,HIGH);
	delayMicroseconds(10);

	time = pulseIn(echoPin,HIGH,23000);
	dist = time / 58.2;

	if(dist < 10 || dist > 400)
		return 0;
	return dist;
}

void loop() {
	if(angle>180){
		angle = 0;
		delay(200);
		for(angle=175;angle>0;angle-=5){
			motor.write(angle);
			delay(10);
			}
		motor.write(0);
		Serial.println("reset");
		Serial.flush();
		delay(300);

		//timing
		prev = crt = millis();
	}else{
		//timing
		while(crt - prev < interval){
			crt = millis();
		}

		//motor
		motor.write(angle);

		//serial
		String buf = String(getDistance(),DEC);
		buf = String(String(angle,DEC)+" "+buf);
		Serial.println(buf);
		Serial.flush();

		//inc angle
		angle += pas;

		//timing
		prev = crt = millis();
	}
}
